class Tdf {    //Data to plot
  
  final int va = 0;  //offsets in records ... for now !
  final int ia = 1;
  final int vg1 = 2;
  final int ig1 = 3;
  final int vg2 = 4;
  final int ig2 = 5;
  final int rnum = 6; // this means 6 fields
  
  FloatList vg1list;
  FloatList vg2list;
  FloatList record;
  float[][] records;
  int recordsCount;
  
//  Plot p;


int setPath(String f){
  if (f == null) return 0;
  config.set("TDFpath",f);
  saveConfig(cFN);
  frame.setTitle(config.get("TDFpath"));  
  return 1;
}
  
  void loadFile(){
//  println("loadFile");
// populate records
  int i, j;
  float v;
  String items[];
  String lines[] = loadStrings(config.get("TDFpath"));  //Get all the lines of the file
  items = new String[rnum];  // Six items per line: va, ia, vg1, ig1,vg2, ig2
  records = new float[lines.length][rnum];
//  println("lines:",lines.length);
  for (i = 0; i < lines.length; i++){  // for each line in lines
    lines[i] = trim(lines[i]);  // removes spurs like crlf !
    items = split(lines[i]," ");
//    println(items.length);
    if (items.length == rnum){  // only if line has 6 fields as expected
      for (j = 0; j < rnum; j++){
//        println(i,j);
        records [i][j] = float(items[j]);
//        println(records[i][j]);
      }
    }
  }
  recordsCount = i;
  vg1list = new FloatList();
  vg2list = new FloatList();


    for (j = 0; j < i; j++){
      v = records[j][vg1];  // the value of vg1 in the record
      if (vg1list.hasValue(v) == false) vg1list.append(v);
      v = records[j][vg2];  // the value of vg2 ..
      if (vg2list.hasValue(v) == false) vg2list.append(v);
    }

/*
    println("Vg1List:");
    for (j = 0; j < vg1list.size(); j++) println(vg1list.get(j));
    println("Vg2List:"); 
    for (j = 0; j < vg2list.size(); j++) println(vg2list.get(j)); 
*/    
    drawGSeries();
  }
  
  void drawGSeries(){
    int i = 0, j = 0;
    pg.beginDraw();
    pg.stroke(0,0,128);
    pg.fill(0,0,128);
    pg.strokeWeight(1.5);
    pg.endDraw();
    for (i = 0; i < vg1list.size(); i++){
      for (j = 0; j < vg2list.size(); j++){
        drawGserie(vg1list.get(i),vg2list.get(j));
//        println("drawGserie:",vg1list.get(i),vg2list.get(j));
      }
    }
  }
  void drawGserie(float g1, float g2){ // draw the serie for the specified grids values
    int i;
    float lastva = 0, lastia = 0, curva = 0, curia = 0;
//      println("g1:",g1);
      pg.beginDraw();
      lastva = records[va][0];
      lastia = records[ia][0];
    for (i = 1; i < recordsCount-1; i++){
      if ((records[i][vg1] == g1) & (records[i][vg2] == g2)){
        curia = records[i][ia];
        curva = records[i][va];
//        println(" va:",curva," ia:",curia);
        pg.line(p.valToPixX(lastva),p.valToPixY(lastia),p.valToPixX(curva),p.valToPixY(curia));
        lastia = curia;
        lastva = curva;
      }
    }
    pg.text(flToHr(g1,"V"),p.valToPixX(lastva),p.valToPixY(lastia));
    pg.endDraw();  
  }    
  
}  //Tdf class end


class Plot {    //Presentation
  float t;  // top
  float l;  // left
  float w;  // width
  float h;  // height
  int grX;  // number of grid X. vertical
  int grY;  // number of grid Y, horizontal
  color grC; // grid color
  color bckC;  // BackGround color
  float fsX;  // Full scale value for X axis
  float fsY;  // Full scale value for Y axis
  float scX;  // scale X
  float scY;  // scale Y
  float pwr;  // Power 
  
  
  
  void init(){
// Values are hard coded for now. Should be settable latter . . .
    grC = color(255,255,255);
    bckC= color(192,192,192);
    t = 0;  // No longer needed because pg is already positioned, but ...
    l = 0;
    w = 800;
    h = 600;
    fsX = 600;  // Means 600V full scale.
    fsY = 0.2;  // Means 200 mA full scale.
    scX = fsX/w;  
    scY = fsY/h;
    grX = 8;
    grY = 8;
    pwr = 50;
  }  
  
/*
Accepts values from a slider i.e. 0 to 1
*/
  void setfsX(float k){
    k = 1-k;  // reverse scale
    if(k == 0) return;  //
    fsX = 1000 * k;    // 1KV full scale
    config.set("fsX",str(fsX));
    scX = fsX/w;
    graticule();
    tdf.drawGSeries();
  }
  
  void setfsY(float k){
    if(k == 0) return;  //
    fsY = k*k;    // 1A full scale, exponential (log) feeling
    config.set("fsY",str(fsY));
    scY = fsY/h;
    graticule();
    tdf.drawGSeries();
  }
  
  void setPwr(float k){
    if (k == 0) return;
    pwr = round(10000 * k * k);
    pwr /= 100;
    config.set("pwr",str(pwr));
    LblPower.setText(flToHr(pwr,"W"));
    LblPower.setTextBold();
    graticule();
    tdf.drawGSeries();
  }    
  
  void graticule(){
//    PGraphics pg;
    int i,j;
    float stp;
  
    pg.beginDraw();
    pg.fill(bckC);
    pg.strokeWeight(1);
    pg.stroke(0,0,0);
    pg.rect (l,t,w-1,h-1,10);  // To draw a border around (in fact, inside) the plot area
    pg.stroke (grC);
    pg.fill(grC);
    pg.textAlign(LEFT,TOP);
    stp = w/grX;
    for (i = 1;i < grX; i++){
      pg.text(" " + flToHr(pixXToVal(l+i*stp),"V"),l+i*stp,t); 
      pg.line(l+i*stp,t,l+i*stp,t+h);
    }
    pg.textAlign(LEFT,BOTTOM);
    stp = h/grY;
    for (i = 1;i < grY; i++){
      pg.text(" " + flToHr(pixYToVal(t+i*stp),"A"),l,t+i*stp);
      pg.line(l,t+i*stp,l+w,t+i*stp);
    }
    pg.endDraw();
    pMax(pwr);
  }
    
  float valToPixX(float val){  //Convert value to pixel according to scX
    return (val/scX+l);  
  }
    
  float valToPixY(float val){ //Convert value to pixel according to scY
    return (t+h-val/scY);
  }
    
  float pixXToVal(float pix){ //Convert pixel to value according to scX
    return ((pix-l)*scX);
  }
    
  float pixYToVal(float pix){ //Convert pixel to value according to scY
    return (fsY-(pix-t)*scY);  //Substract from fsY to move origin at bottom.
  }
    
  void pMax(float pwr){
    pg.beginDraw();
    float ib,ie,vb,ve;  // begin and end of a segment 
    float d = fsX/50;  // delta
    pg.strokeWeight(1.5);
    pg.stroke(255,128,128);
//    println("pMax",fsX,fsY);
    for (ib = fsY, ve = pwr/ib; ve <= fsX; ve +=d){
      vb = pwr/ib;
//      ve += d;
      if (ve >= fsX) ve = fsX ;
      ie = pwr/ve;
      pg.line(valToPixX(vb),valToPixY(ib),valToPixX(ve),valToPixY(ie));
      vb = ve;
      ib = ie;
    }
    pg.endDraw();
  }
  void flyV(float x, float y){
    pg.beginDraw();
    pg.fill(0,0,0);
    pg.blendMode(SUBTRACT);
    pg.text("Flyier",x,y);
    pg.endDraw();
  } 
} //Plot class end

